;       cpu  Z80UNDOC

;       RELAXED ON

         
;RUSSIAN KEMPSTON MOUSE DRIVER

	org #FE00         

	output kmdrvshortAFORCE2.bin

XMAX     equ  255
XMIN     equ  0
         
YMAX     equ  108
YMIN     equ  0
         
;XECUTE MOUSE
;TAKE COORDINATES FROM CURPOS=
;=COORD
         
MOUSE    
         ld   hl,(COORD)
;L=X-axis
;H=Y-axis
         ld   bc,$FBDF
         ld   de,(OLDCO)
         in   a,(c)
         ld   (OLDCO),a
         sub  e
         jr   z,NM_X
         jp   p,MX_PL
         add  a,l
         jr   c,ZER_X
         xor  a
ZER_X    ld   l,a
         jr   NM_X
MX_PL    add  a,l
         jr   c,BEX_Z
         cp   XMAX
         jr   c,BEX_B
BEX_Z    ld   a,XMAX
BEX_B    ld   l,a
NM_X     ld   b,$FF
         in   a,(c)
         ld   (OLDCO+1),a
         sub  d
         jr   z,NM_Y
         neg  
         jp   p,MY_PL
         add  a,h
         jr   c,ZER_Y
         xor  a
ZER_Y    ld   h,a
         jr   NM_Y
MY_PL    add  a,h
         jr   c,BEY_Z
         cp   YMAX
         jr   c,BEY_B
BEY_Z    ld   a,YMAX
BEY_B    ld   h,a
NM_Y     ld   a,h
         cp   $FF
         jr   c,BIGY
         ld   h,$FF
BIGY     cp   YMIN
         jr   nc,SMALY
         ld   h,YMIN
SMALY    ld   a,l
         cp   $FF
         jr   c,DIRY
         ld   l,$FF
DIRY     cp   XMIN
         jr   nc,DIMENS
         ld   l,XMIN
DIMENS   ld   (COORD),hl
         ld   bc,$FADF
         in   a,(c)
         cpl  
         and  7
         ld   (CONTRB),a
	ret  
;------------------------------
;INPUT: L=new X-axis
;       H=new Y-axis
         
KOREKCE  ld   a,$FB
         in   a,($DF)
         ld   (OLDCO),a
         ld   a,$FF
         in   a,($DF)
         ld   (OLDCO+1),a
         ld   (COORD),hl
         ret  
;------------------------------
;new cursor position
COORD    defb 0,0
         
;buttons status
CONTRB   defb 0
         
;working (previous position)
OLDCO    defb 0,0
;------------------------------
LENGTH   equ  $-MOUSE

kor_lev	ld h,c
	ld a,b
	add a,a
	add a,a
	add a,a
	add a,b
	ld l,a
;	ld hl,#4075
	call KOREKCE
	ld a,(#ED95)
	ret

start	push hl			;musime zachovat HL kvuli hre
	push de
	ld a,c
	ld (obnov+1),a
	call MOUSE
	ld b,0
	jr z,no_fire		;Z=tlacitko nestisteno
	and 4
	jr nz,no_fire		;prostredni tlacitko ignorujeme
	ld b,16			;stisk tlacitka
no_fire	ld a,(#6118)		;kvuli vysvobozeni zajatcu
	cp #80
	jr z,obnov
	ld a,(#6100)		;kvuli vysvobozeni zajatcu, aby nebyl videt krizek
	inc a
	jr z,obnov
	ld e,255
	ld a,l
lom	sub 9
	inc de
	jr nc,lom
	ld a,e			;a=nova hodnota sloupce upravena pro hru
	ld de,(#6100)		;de=stara hodnota souradnic pro hru
	ld (#6100),a		;zapiseme novou hodnotu sloupce
	sub e
	jr z,updown		;zadny posun vlevo/vpravo=test zmeny nahoru/dolu

	push hl
	ld hl,(#6102)
	jr c,left
right	inc hl
	dec a
	jr nz,right
	jr endlr
left	cpl
	inc a
left1	dec hl
	dec a	
	jr nz,left1
endlr	ld (#6102),hl
	pop hl

updown	ld a,h			;test posunu nahoru/dolu
	and 252			;zaokrouhli 4
	cp d
;	sub d
;	ret z			;posun nebyl
	jr nz,upd1
;	call #C6F7		;pak volej prislusny ovladac, musime vyhodit, u kmouse nejde strelba
	jr obnov
upd1	ld (#6101),a
;	push bc
	ld de,(#6100)	
;	ld hl,#6100
;	ld b,(hl)
;	inc hl
;	ld c,(hl)

	ld a,d		;vypocetni rutina ze hry bylo a,c
;	ld c,b
	and #F8
	ld l,a
	ld h,0
	ld d,h		;bylo b,h
;	ld d,h	;???
	add hl,hl
	add hl,hl
	add hl,de
;	add hl,bc	;hl=druhe souradnice
	ld (#6102),hl
;	pop bc
obnov	ld c,#55
	pop de
	pop hl	
	ret

	
;	jr c,up
;	srl a
;	srl a
;	push bc			;down call D1CD, in: e=4
;	ld b,a
;down	ld e,4
;	call #D1CD
;	djnz down
;	pop bc
;	ret
;up	cpl
;	inc a
;	srl a			;up, call D20C
;	srl a			;deleno 4
;	push bc			;pocet zvyseni up/down
;	ld b,a
;up1	call #D20C
;	djnz up1
;	pop bc
;	ret


